<template>
  <div class="ele-body">
    <el-card shadow="never" v-loading="loading">
      <order-search
        ref="searchRefs"
        @search="reload"
        :selection="selection"
        :activeName="activeName"
      >
      </order-search>
      <el-tabs v-model="activeName" type="card">
        <el-tab-pane label="待排产" name="first"></el-tab-pane>
        <el-tab-pane label="已排产" name="second"></el-tab-pane>
      </el-tabs>
      <!-- 数据表格 -->
      <ele-pro-table
        ref="table"
        :columns="newColumns"
        :initLoad="false"
        :datasource="datasource"
        :selection.sync="selection"
        cache-key="systemRoleTable1"
        height="calc(100vh - 335px)"
        row-key="id"
        @sort-change="onSortChange"
      >
        <template v-slot:code="{ row }">
          <el-link :underline="false" type="primary" @click="openDetails(row)">
            {{ row.code }}
          </el-link>
        </template>

        <template v-slot:priority="{ row }">
          <div style="display: flex">
            <el-input
              v-model="row.priority"
              type="number"
              size="mini"
              :min="0"
              :max="10"
              @change="priorityChange(row)"
              style="width: 80px"
            ></el-input>
            <el-popover
              placement="right"
              width="200"
              trigger="hover"
              content="数值越大优先级越高（0-3普通, 4-6优先, 7-10紧急）"
            >
              <div class="sort-wrap" slot="reference">
                <i class="el-icon-caret-top" @click="sortTop(row)"></i>
                <i class="el-icon-caret-bottom" @click="sortBottom(row)"></i>
              </div>
            </el-popover>
          </div>
        </template>

        <template v-slot:productSumWeight="{ row }">
          {{ row.productSumWeight }} {{ row.weightUnit }}
        </template>

        <template v-slot:contractNum="{ row }">
          {{ row.contractNum }} {{ row.measuringUnit }}
        </template>

        

        <!-- 操作列 -->
        <template v-slot:action="{ row }">
          <template>
            <el-link
              v-if="row.orderSource != 1 && activeName == 'first'"
              type="primary"
              :underline="false"
              icon="el-icon-edit"
              @click="toUpdate(row)"
            >
              修改
            </el-link>

            <el-popconfirm
              v-if="row.orderSource != 1 && activeName == 'first'"
              class="ele-action"
              title="确定要删除此销售订单吗？"
              @confirm="remove(row)"
            >
              <template v-slot:reference>
                <el-link type="danger" :underline="false" icon="el-icon-delete">
                  删除
                </el-link>
              </template>
            </el-popconfirm>
          </template>
        </template>
      </ele-pro-table>
    </el-card>
    <!-- 详情弹窗 -->
    <order-detail @refresh="reload" ref="detailDialog"> </order-detail>
    <!-- 创建订单 -->
    <create-order ref="createDialog" @refresh="reload"> </create-order>
  </div>
</template>

<script>
  import OrderSearch from './components/order-search.vue';
  import OrderDetail from './components/order-detail.vue';
  import CreateOrder from './components/create-order.vue';

  import {
    getPageList,
    deleteOrder,
    updatePriority,
    fieldModel
  } from '@/api/saleOrder';
  import dictMixins from '@/mixins/dictMixins';
  import { debounce } from 'lodash';
  import { Alert } from 'element-ui';
  export default {
    name: 'saleOrder',
    mixins: [dictMixins],
    components: {
      OrderSearch,
      OrderDetail,
      CreateOrder
    },
    data() {
      return {
        // 加载状态
        loading: false,
        activeName: 'first',
        selection: [],

        newColumns: []
      };
    },

    computed: {
      // 表格列配置
      clientEnvironmentId() {
        return this.$store.state.user.info.clientEnvironmentId;
      },
      columns() {
        return [
          {
            width: 45,
            type: 'selection',
            columnKey: 'selection',
            align: 'center',
            selectable: (row, index) => {
              return this.activeName != 'second';
            }
          },
          {
            columnKey: 'index',
            label: '序号',
            type: 'index',
            width: 55,
            align: 'center',
            showOverflowTooltip: true,
            fixed: 'left'
          },
          {
            prop: 'code',
            label: '销售订单号',
            align: 'center',
            showOverflowTooltip: true,
            minWidth: 150,
            slot: 'code',
            sortable: true
          },
          {
            prop: 'lineNumber',
            label: '行号',
            align: 'center',
            showOverflowTooltip: true
          },
          {
            prop: 'productCode',
            label: '产品编码',
            align: 'center',
            showOverflowTooltip: true,
            minWidth: 140,
            sortable: true
          },

          {
            prop: 'productName',
            label: '产品名称',
            align: 'center',
            minWidth: 120
          },

          {
            prop: 'produceRoutingName',
            label: '工艺路线',
            align: 'center',
            minWidth: 120
          },

          {
            prop: 'brandNo',
            label: '牌号',
            align: 'center'
          },
          {
            prop: 'specification',
            label: '规格',
            align: 'center',
            minWidth: 150,

            showOverflowTooltip: true
          },
          {
            prop: 'model',
            label: '型号',
            align: 'center',
            minWidth: 120
          },
          {
            prop: 'priority',
            label: '优先级',
            align: 'center',
            minWidth: 120,
            slot: 'priority',
            sortable: 'custom'
          },

          {
            prop: 'productSumWeight',
            label: '订单重量',
            align: 'center',
            slot: 'productSumWeight'
          },
          {
            prop: 'contractNum',
            slot: 'contractNum',
            label: this.clientEnvironmentId == '4' ? '交付数量' : '订单数量',
            align: 'center'
          },
          {
            prop: 'lackNum',
            label: '欠交数量',
            align: 'center'
          },
          {
            prop: 'moCount',
            label: '模数',
            align: 'center',
            show: this.clientEnvironmentId == '4'
          },
          {
            prop: 'blockCount',
            label: '块数',
            align: 'center',
            show: this.clientEnvironmentId == '4'
          },
          {
            prop: 'orderLibraryType',
            label: '按单按库',
            align: 'center',
            showOverflowTooltip: true,
            formatter: (_row, _column, cellValue) => {
              return this.getDictValue('按单按库', _row.orderLibraryType);
            }
          },
          {
            prop: 'deliveryRequirements',
            label: '交付要求',
            align: 'center',
            showOverflowTooltip: true,
            formatter: (_row, _column, cellValue) => {
              return this.getDictValue('交付要求', _row.deliveryRequirements);
            }
          },
          {
            prop: 'orderType',
            label: '订单类型',
            align: 'center',
            showOverflowTooltip: true,
            formatter: (_row, _column, cellValue) => {
              return this.getDictValue('订单类型', _row.orderType);
            }
          },
          {
            prop: 'orderSource',
            label: '订单来源',
            align: 'center',
            showOverflowTooltip: true,
            formatter: (_row, _column, cellValue) => {
              return this.getDictValue('订单来源', _row.orderSource);
            }
          },
          {
            prop: 'status',
            label: '生产状态',
            align: 'center',
            showOverflowTooltip: true,
            formatter: (_row, _column, cellValue) => {
              return this.getDictValue('生产状态', _row.status);
            }
          },
          {
            prop: 'releaseTime',
            label: '下达时间',
            align: 'center',
            showOverflowTooltip: true
          },
          {
            prop: 'deliveryTime',
            label: '交付日期',
            align: 'center',
            showOverflowTooltip: true
          },
          {
            prop: 'customerName',
            label: '客户名称',
            align: 'center',
            showOverflowTooltip: true
          },

          {
            prop: 'serialNo',
            label: '客户代号',
            align: 'center',
            showOverflowTooltip: true
          },

          {
            prop: 'simpleName',
            label: '客户简称',
            align: 'center',
            showOverflowTooltip: true
          },

          {
            prop: 'salesman',
            label: '业务员',
            showOverflowTooltip: true
          }
        ];
      }
    },
    created() {
      this.getFieldModel();

      this.requestDict('按单按库');
      this.requestDict('交付要求');
      this.requestDict('订单类型');
      this.requestDict('订单来源');
      this.requestDict('生产状态');
    },
    methods: {   
      
      getFieldModel() {
        fieldModel({ fieldModel: 't_main_category' }).then((res) => {
          const privateColumn = [];
          if (this.activeName == 'first') {
            privateColumn.push({
              columnKey: 'action',
              label: '操作',
              width: 130,
              align: 'center',
              resizable: false,
              slot: 'action',
              fixed: 'right'
            });
          } else {
            privateColumn = [];
          }

          let newRes = res.map((m) => {
            return {
              prop: 'extField.' + m.prop,
              label: m.label,
              align: 'center',
              showOverflowTooltip: true
            };
          });

          this.newColumns = [...this.columns, ...newRes, ...privateColumn];

          this.$forceUpdate();
        });
      },

      /* 表格数据源 */
      async datasource({ page, limit, where, order }) {
        if (this.activeName == 'first') {
          where.status = [1];
        } else {
          if (where.proStu) {
            where.status = [where.proStu];
          } else {
            where.status = [2, 3, 4, 5, 6, 7];
          }
        }
        const params = {
          size: limit,
          pageNum: page,
          ...where,
          ...this.sort
        };
        const data = await getPageList(params);
        return data;
      },

      /* 刷新表格 */
      reload(where) {
        this.$nextTick(() =>
          this.$refs.table.reload({ page: 1, limit: 10, where })
        );
      },

      openDetails(row) {
        this.$refs.detailDialog.open(row);
      },
      toUpdate(row) {
        this.$refs.createDialog.open(row);
      },

      remove(row) {
        deleteOrder([row.id]).then((res) => {
          this.$message.success(res);
          this.reload();
        });
      },

      onSortChange(e) {
        let sort = {
          orderBy: e.order,
          sortName: e.prop
        };
        this.sort = sort;
        this.reload();
      },

      sortTop(row) {
        row.priority = Number(row.priority) + 1;
        this.priorityChange(row);
      },
      sortBottom(row) {
        if (row.priority <= 1) {
          return;
        }
        row.priority = Number(row.priority) - 1;
        this.priorityChange(row);
      },

      priorityChange(row) {
        if (row.priority > 10) {
          row.priority = 10; // 如果大于 10，则设置为 10
        } else if (row.priority < 0) {
          row.priority = 0; // 如果小于 0，则设置为 0
        }

        this.priorityFn(row);
      },
      priorityFn: debounce(function (row) {
        let params = {
          id: row.id,
          priority: row.priority
        };
        updatePriority(params).then((res) => {});
      }, 800)
    }
  };
</script>

<style lang="scss" scoped></style>
